require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_PTHREADTYPES_H)) {
    eval 'sub _PTHREADTYPES_H () {1;}' unless defined(&_PTHREADTYPES_H);
    require 'features.ph';
    require 'bits/types.ph';
    require 'bits/pthread.ph';
    eval("sub __PTHREAD_PROCESS_PRIVATE () { 0; }") unless defined(&__PTHREAD_PROCESS_PRIVATE);
    eval("sub __PTHREAD_PROCESS_SHARED () { 1; }") unless defined(&__PTHREAD_PROCESS_SHARED);
    eval("sub __PTHREAD_EXPLICIT_SCHED () { 0; }") unless defined(&__PTHREAD_EXPLICIT_SCHED);
    eval("sub __PTHREAD_INHERIT_SCHED () { 1; }") unless defined(&__PTHREAD_INHERIT_SCHED);
    eval("sub __PTHREAD_SCOPE_SYSTEM () { 0; }") unless defined(&__PTHREAD_SCOPE_SYSTEM);
    eval("sub __PTHREAD_SCOPE_PROCESS () { 1; }") unless defined(&__PTHREAD_SCOPE_PROCESS);
    eval("sub __PTHREAD_CREATE_JOINABLE () { 0; }") unless defined(&__PTHREAD_CREATE_JOINABLE);
    eval("sub __PTHREAD_CREATE_DETACHED () { 1; }") unless defined(&__PTHREAD_CREATE_DETACHED);
    require 'bits/thread-attr.ph';
    eval("sub __PTHREAD_PRIO_NONE () { 0; }") unless defined(&__PTHREAD_PRIO_NONE);
    eval("sub __PTHREAD_PRIO_INHERIT () { 1; }") unless defined(&__PTHREAD_PRIO_INHERIT);
    eval("sub __PTHREAD_PRIO_PROTECT () { 2; }") unless defined(&__PTHREAD_PRIO_PROTECT);
    eval("sub __PTHREAD_MUTEX_TIMED () { 0; }") unless defined(&__PTHREAD_MUTEX_TIMED);
    eval("sub __PTHREAD_MUTEX_ERRORCHECK () { 1; }") unless defined(&__PTHREAD_MUTEX_ERRORCHECK);
    eval("sub __PTHREAD_MUTEX_RECURSIVE () { 2; }") unless defined(&__PTHREAD_MUTEX_RECURSIVE);
    eval("sub __PTHREAD_MUTEX_STALLED () { 0; }") unless defined(&__PTHREAD_MUTEX_STALLED);
    eval("sub __PTHREAD_MUTEX_ROBUST () { 0x100; }") unless defined(&__PTHREAD_MUTEX_ROBUST);
    require 'bits/mutex-attr.ph';
    require 'bits/mutex.ph';
    require 'bits/condition-attr.ph';
    require 'bits/condition.ph';
    if(defined(&__USE_XOPEN2K)) {
	require 'bits/spin-lock.ph';
    }
    if(defined (&__USE_UNIX98) || defined (&__USE_XOPEN2K)) {
	require 'bits/rwlock-attr.ph';
	require 'bits/rwlock.ph';
    }
    if(defined(&__USE_XOPEN2K)) {
	require 'bits/barrier-attr.ph';
	require 'bits/barrier.ph';
    }
    require 'bits/thread-specific.ph';
    require 'bits/once.ph';
}
1;
